program FdscInformer;

// FDSC Informer
//  .. 2006 .

//  .   .

{
         
    korea.sionyx.ru     ,    
        

        php-
    fdscinf.php,        

            
    strings.ini    ,    

      Delphi 7.    Windows 98,
             unicode.   
      Windows 98    unicode-  ANSI.
}

{%File 'Errors.txt'}

uses
  windows,
  messages,
  VinUnicode in 'VinUnicode.pas',
  InternalStrings in 'InternalStrings.pas',
  uMenus in 'uMenus.pas',
  uConsts in 'uConsts.pas',
  shellAPI,
  uHintIcon in 'uHintIcon.pas',
  uInternetAccess in 'uInternetAccess.pas',
  uRegistry in 'uRegistry.pas';

{$R *.res}

var
  TaskBarCreatedMessage : cardinal;

procedure RefreshURL; forward;
procedure RefreshMenuBE(ID : cardinal);  forward;
procedure RefreshMenuTB(ID : cardinal);  forward;
procedure RefreshMenuRun(ID : cardinal); forward;
function  onTimer(hwnd, wparam, lparam : cardinal): boolean; forward;

function InitializeShell(hwnd: cardinal; Msg: cardinal; Icon : cardinal = 102): boolean;
begin
  result := false;
  NCD.cbSize := sizeof(NotifyIconData);
  NCD.Wnd   := hwnd;
  NCD.uID    := 32641;
  NCD.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  NCD.uCallbackMessage := WM_NOTIFYICON;
  NCD.hIcon  := LoadIcon(hInstance, pointer(Icon));
  StrCopyToArray(IconTitle, @NCD.szTip[0]);

  if ( NOT Shell_NotifyIconW(Msg, @NCD) ) and ( Msg <> NIM_DELETE ) then
  begin
    MsgBox(0, IconNotifyFailed + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    SendMessage(hwnd, WM_CLOSE, 0, 0);
  end;
end;

function InitDialog(hwnd : cardinal): boolean;
begin
  hdlg   := hwnd;
  result := InitializeShell(hwnd, NIM_ADD);

  CheckAutoRun;

  SetTimer(hwnd, 2, 1000, nil);
  
  hMenu  := CreateTrayMenu(hwnd);
  if hMenu = 0 then
  begin
    MsgBox(0, MenuFailed + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    SendMessage(hwnd, WM_CLOSE, 0, 0);
  end;
  
  LoadRefreshTimeInMenu(hwnd, hSubMenuI);
  RefreshMenuBE (MENU_BROWSERE);
  RefreshMenuTB (MENU_TBOFF);
  RefreshMenuRun(MENU_RUN);
  RefreshURL;
  Initialized := true;
end;

function EndDlg(hwnd : cardinal): boolean;
begin
  EndDialog(hwnd, 1);
  result := true;
end;

function onIconClick(hwnd: cardinal): boolean;
var
  P : TPoint;
begin
  GetCursorPos(P);
  SetForegroundWindow(hwnd);
  TrackPopupMenu(hMenu, TPM_LEFTALIGN, P.X, P.Y, 0, hwnd, nil);
  result := true;
end;

function onMouseMove(hwnd: cardinal): boolean;
begin
  result := true;
end;

function onIcon(hwnd, uID, msg : cardinal): boolean;
begin
  result := true;
  case msg of
    WM_LBUTTONUP:   result := onIconClick(hwnd);
    WM_RBUTTONDOWN: result := onIconClick(hwnd);
    WM_MOUSEMOVE  : result := onMouseMove(hwnd);
  end;
end;

function onMenuClose(hwnd, lparam: cardinal): boolean;
begin
  PostMessage(hwnd, WM_CLOSE, 0, 0);  
  result := true;
end;

function OnIntervalCommand(hwnd, wparam, lparam: cardinal): boolean;
begin
  result := true;
  IntervalSubMenusAllUnCheck(hwnd, hSubMenuI);
  IntervalSubMenusCheck(hwnd, hMenu, wparam);
  RefreshTime := RefreshIntervals[wparam - MENU_INTERVAL];
  SaveStrings;
end;

procedure RefreshMenuBE(ID : cardinal);
begin
  if BrowserExec then
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_CHECKED)
  else
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_UNCHECKED);
  SaveStrings;
end;

function OnMenuBE(hwnd, wparam: cardinal): boolean;
begin
  result := true;
  BrowserExec := NOT BrowserExec;
  RefreshMenuBE(wparam);
  SaveStrings;
end;

function onMenuRR(hwnd, wparam: cardinal): boolean;
begin
  result := true;
  Dec(LastMsgCode);
  Dec(LastNewCode);
  onTimer(hwnd, 3, 0);
end;

procedure RefreshMenuTB(ID : cardinal);
begin
  if troubleOff then
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_CHECKED)
  else
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_UNCHECKED);
end;

function onMenuTB(hwnd, wparam: cardinal): boolean;
begin
  result := true;
  
  troubleOff := NOT troubleOff;
  RefreshMenuTB(wparam);
  SaveStrings;
end;

procedure RefreshMenuRun(ID : cardinal);
begin
  if IsRun then
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_CHECKED)
  else
    CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_UNCHECKED);
end;

function OnMenuRun(hwnd, wparam: cardinal): boolean;
begin
  IsRun := NOT IsRun;
  CheckAutoRun();
  RefreshMenuRun(wparam);
  Result := true;
  SaveStrings;
end;

function onCommand(hwnd, wparam, lparam: cardinal): boolean;
begin
  result := false;

  if (wparam > MENU_INTERVAL) and (wparam <= MENU_INTERVAL + Nintervals) then
    OnIntervalCommand(hwnd, wparam, lparam)
  else case wparam of
    MENU_CLOSE: result := onMenuClose (hwnd, lparam);
//    MENU_UA   : result := onMenuUA    (hwnd, wparam);    - " "
    MENU_BROWSERE : result := onMenuBE (hwnd, wparam);
    MENU_RR       : result := onMenuRR (hwnd, wparam);
    MENU_TBOFF    : result := onMenuTB (hwnd, wparam);
    MENU_RUN      : result := OnMenuRun(hwnd, wparam);
  end
end;

procedure BrowserFile(FileName: ANSIString);
var
  Open: PAnsiChar;
  Dir : PAnsiChar;
//  I   : cardinal;
begin
  if NOT BrowserExec then exit;
  Dir := pointer(LocalAllocP(2048));
  GetCurrentDirectory(2048, Dir);

{  I := 0;
  while Dir[I] <> #0 do inc(I);
  while (Dir[I] <> '/') and (Dir <> '\') do inc(I);
  Dir[I] := #0;}
  
  Open := pointer(LocalAllocP(2048));
  FindExecutable(@FileName[1], Dir, Open);

  FileName := Dir + '/' + FileName;

  ShellExecute(hdlg, 'open', Open, @FileName[1], Dir, SW_SHOW);
end;

function GetFileURL(URL: WideString = ''): WideString;
var
  Str: WideString;
begin
  if URL = '' then URL := FileURL;

  Str := ReadURL(URL);
  if IsFound(Str) then result := str else result := '';
end;

const
  MaxViewCalls = 5;  

var
  ViewNewCalls : cardinal = 0;

// true if error
function ViewNew(FileStr: WideString; NewCount : integer): boolean;
var
  FileName : ANSIstring;
  Content  : WideString;
  NewsTag  : WideString;
  OneNews  : WideString;
  SiteNew  : WideString;
  NewIdent : WideString;
  Date     : WideString;
  I, Ch    : integer;
begin
  result := false;
  if NewCount < 1 then exit;
  if NewCount > 1 then FileStr := GetFileURL(FileURL + '?news=' + CarToStrW(NewCount) + '&gb=0');

  Inc(ViewNewCalls);
  Content := '';
  Ch      := 0;
  for I := 1 to NewCount do
  begin
    NewsTag  := GetContentOfElementByIndex(FileStr, 'news', I);
    if NewsTag = '' then break;
    OneNews  := GetContentOfElementByIndex(NewsTag, 'ournews', 1);
    SiteNew  := GetContentOfElementByIndex(NewsTag, 'sitenews', 1);
    Date     := GetContentOfElementByIndex(NewsTag, 'date', 1);
    NewIdent := Trim(GetContentOfElementByIndex(NewsTag, 'ident', 1));
    if (OneNews <> 'blank') and (OneNews <> '') then
      Content := Content + STC('DIV', OurNews + ' ' + Date + ' <br>' + OneNews + '<hr><br>');
    if (SiteNew <> 'blank') and (SiteNew <> '') then
      Content := Content + STC('DIV', SiteNews + ' ' + Date + ' <br>' + SiteNew + '<hr><br>');
    inc(Ch);
  end;

  Content := ReplaceSmiles(Content);
  Content := STC('body', Content);
  Content := STC('html', Content);
  inc(LastNewCode, NewCount);

  if (Ch < NewCount) and (ViewNewCalls < MaxViewCalls) then
  begin
    result := ViewNew(FileStr, NewCount);
    Dec(ViewNewCalls);
    exit;
  end
  else if (Ch <> NewCount) and (ViewNewCalls >= MaxViewCalls) then
  begin
    ShowBalloonHint('FDSC Informer', NotAllReceived, bitWarning);
    result := true;
  end;

  FileName := 'n' {+ CarToStr(LastNewCode + 1) }+ '.html';
//  if EnabledUA then -  ,   (" ")

  if (BrowserExec) then
  begin
    SetFile(FileName, Content);
    BrowserFile(FileName);
  end;
  Dec(ViewNewCalls);
end;

var
  ViewMsgCalls : cardinal = 0;

// true if error
function ViewMsg(FileStr: WideString; MsgCount : integer): boolean;
var
  FileName : ANSIstring;
  Content  : WideString;
  OneMsg   : WideString;
  MsgIdent : WideString;
  User     : WideString;
  Date     : WideString;
  I , Ch   : integer;
begin
  result := false;
  if MsgCount < 1 then exit;
  if MsgCount > 1 then FileStr := GetFileURL(FileURL + '?news=0&gb=' + CarToStrW(MsgCount));

  Inc(ViewMsgCalls);
  Content := '';
  Ch      := 0;
  for I := 1 to MsgCount do
  begin
    OneMsg   := GetContentOfElementByIndex(FileStr, 'gbmessage', I);
    if OneMsg = '' then break;
    MsgIdent := Trim(GetContentOfElementByIndex(OneMsg, 'ident', 1));
    User     := GetContentOfElementByIndex(OneMsg, 'user', 1);
    Date     := GetContentOfElementByIndex(OneMsg, 'date', 1);
    OneMsg   := GetContentOfElementByIndex(OneMsg, 'message', 1);
    Content  := Content + STC('DIV', '<hr>user:<b>&nbsp' + User + '</b>. Date: ' + Date + '<br>' + OneMsg + '<hr><br>');
    inc(Ch);
  end;

  Content := ReplaceSmiles(Content);
  Content := STC('body', Content);
  Content := STC('html', Content);
  inc(LastMsgCode, MsgCount);

  if (Ch < MsgCount) and (ViewMsgCalls < MaxViewCalls) then
  begin
    result := ViewMsg(FileStr, MsgCount);
    Dec(ViewMsgCalls);
    exit;
  end
  else if (Ch <> MsgCount) and (ViewMsgCalls >= MaxViewCalls) then
  begin
    ShowBalloonHint('FDSC Informer', NotAllReceived, bitWarning);
    result := true;
  end;

  FileName := 'm'{ + CarToStr(LastMsgCode + 1)} + '.html';

  if (BrowserExec) then
  begin
    SetFile(FileName, Content);
    BrowserFile(FileName);
  end;
  Dec(ViewMsgCalls);
end;

procedure FileRender(FileStr: WideString);
var
  El : WideString;
  ECode, MsgCode, NewCode : cardinal;
  HaveNews, HaveMsg, Synchro : boolean;
  Err, ErrReceive : boolean;
begin
  El := GetContentOfElementByIndex(FileStr, 'gbmessage', 1);
  El := GetContentOfElement(El, 'ident');

  ErrReceive := false;
  HaveMsg    := false; HaveNews := false; Synchro := false;
  err := el = '';
  if el <> '' then
  begin
    Val(El, MsgCode, ECode);

    if ECode <> 0 then
    begin
      ShowBalloonHint('FDSC Informer', ErrorCode + ': ' + El + ' msg', bitInfo); exit;
    end
    else Synchro := cardinal(MsgCode - LastMsgCode) > 50;

    HaveMsg     := LastMsgCode < MsgCode;

    if (ECode = 0){ and (LastMsgCode < MsgCode)} then
    begin
      if Synchro or (integer(MsgCode - LastMsgCode) < 0) then
        LastMsgCode := MsgCode
      else ErrReceive := ViewMsg(FileStr, MsgCode - LastMsgCode);
    end;
  end;
  
  El := GetContentOfElementByIndex(FileStr, 'news', 1);
  El := Trim(GetContentOfElement(El, 'ident'));
  err := err and (el = '');
  if el <> '' then
  begin
    Val(El, NewCode, ECode);

    if ECode <> 0 then
    begin
      ShowBalloonHint('FDSC Informer', ErrorCode + ': ' + El + ' news', bitError); exit;
    end
    else Synchro := Synchro or ((NewCode - LastNewCode) > 15);

    HaveNews    := LastNewCode < NewCode;

    if (ECode = 0) {and (LastNewCode < NewCode)} then
    begin
      if Synchro or (integer(NewCode - LastNewCode) < 0) then
        LastNewCode := NewCode
      else ErrReceive := ErrReceive or ViewNew(FileStr, NewCode - LastNewCode);
    end;
  end;
  
  if Synchro then
    ShowBalloonHint('FDSC Informer', SynchroNM,  bitInfo)
  else if HaveNews or HaveMsg then
  begin
    if NOT ErrReceive then
    if HaveMsg and NOT HaveNews then
      ShowBalloonHint('FDSC Informer', NewMsg,  bitInfo)
    else if NOT HaveMsg and HaveNews then
      ShowBalloonHint('FDSC Informer', NewNews, bitInfo)
    else
      ShowBalloonHint('FDSC Informer', NewNM, bitInfo);
  end;

  if Err then
  begin
    if (NOT FileCorrupt) and (NOT TroubleOff) then
      ShowBalloonHint('FDSC Informer', 'Getting file is corrupted', bitInfo);
    if NOT FileCorrupt then
      InitializeShell(hdlg, NIM_MODIFY, 103);
    FileCorrupt := true;
    PostMessage(hdlg, WM_USER+80, 3, 0);
  end else
  begin
    if FileCorrupt then
      InitializeShell(hdlg, NIM_MODIFY, 102);
    FileCorrupt := false;
  end;

  SaveStrings;
end;

procedure AccessToURL(IsAcc : boolean);
begin
  if IsAccess <> IsAcc then
    if IsAcc = false then
    begin
      InitializeShell(hdlg, NIM_MODIFY, 104);
      if NOT troubleOff then
        ShowBalloonHint('FDSC Informer', NATS, bitWarning);
    end
    else begin
     InitializeShell(hdlg, NIM_MODIFY, 102);
     if NOT troubleOff then
       ShowBalloonHint('FDSC Informer', RATS, bitInfo);
    end;

  IsAccess := IsAcc;

  if IsAccess then FileRender(FileStr);
end;

procedure RefreshURL;
begin
  LastRefresh := TimerCount;

  FileStr   := GetFileURL;
  AccessToURL(FileStr <> '');
end;

procedure TimerStatus();
begin
  if RefreshTime <> 0 then
  begin
    if NOT( (LastRefresh = TimerCount) and (LastRefresh <> 0) ) then
      if (TimerCount mod RefreshTime) = 0 then
      RefreshURL;
  end;

  if IsHint and (TimerCount - LastHint > HintTime) then
    HideBalloonHint;
end;

var
  TT3 : integer = 0;

function onTimer(hwnd, wparam, lparam : cardinal): boolean;
begin
  result := false;
  if NOT Initialized then exit;
  if wparam = 1 then
  begin
    TT3 := 0;
  end
  else if wparam = 2 then
  begin
    result := true;
    Inc(TimerCount);
    TimerStatus;
    TT3 := 0;
  end
  else if wparam = 3 then
  begin
    inc(TT3);
    if TT3 > 40 then TT3 := 0
    else RefreshURL;
  end;
end;

function onClose(hwnd : cardinal): boolean;
begin
  Terminated := true;
  KillTimer(hwnd, 2);
  result := EndDlg(hwnd);
end;

function HideWindow(hwnd: cardinal): boolean;
begin
  ShowWindow(hwnd, SW_HIDE);
  result := true;
end;

function Msg(hwnd: cardinal; msg: cardinal; wparam: cardinal; lparam: cardinal): boolean; stdcall;
begin
  result := false;
  if (msg > WM_USER) and (msg < WM_USER + 6) then result := true;
  case msg of
    WM_INITDIALOG : result := InitDialog(hwnd);
    WM_DESTROY    : result := InitializeShell(hwnd, NIM_DELETE);
    WM_CLOSE      : result := onClose  (hwnd);
    WM_TIMER      : result := onTimer  (hwnd, wparam, lparam);
    WM_NOTIFYICON : result := onIcon   (hwnd, wparam, lparam);
    WM_COMMAND    : result := onCommand(hwnd, wparam, lparam);
    WM_USER+80    : result := OnTimer  (hwnd, 3,      lparam);
    WM_PAINT      : result := HideWindow(hwnd);
    else if TaskBarCreatedMessage = msg then
    begin
      if NOT IsAccess then
        result   := InitializeShell(hwnd, NIM_ADD, 104)
      else
        result   := InitializeShell(hwnd, NIM_ADD);
    end;
  end;
end;

procedure CreateDialog;
begin
  TaskBarCreatedMessage := RegisterWindowMessage('TaskbarCreated');

  if windows.DialogBoxW(hInstance, pointer(101), 0, @Msg) = -1 then
  begin
    GetError(GetLastError, true);
    exit;
  end;
end;

begin
  hInstance := windows.GetModuleHandle(nil);
  SetLastError(0);

//  MsgBox(0, GetFile('strings.ini'), 'caption');
  if SuccessInternalStringsLoading and NOT Terminated
  then CreateDialog;
end.

