unit InternalStrings;

// FDSC Informer
//  .. 2006 .

//    strings.ini (.  STRINGS) -
//   +  

interface

uses windows, VinUnicode, uConsts, uInternetAccess, uRegistry, shellapi;

var
  SuccessInternalStringsLoading : boolean = false;
  IniStr    : WideString;
  FileStr   : WideString;

  RTstring  : WideString;
  trbleOff  : WideString;
  SiteURL   : WideString;
  FileURL   : WideString;
  HintTimeS : WideString;
  OurNews   : WideString;
  SiteNews  : WideString;

  EnabledUA_STRING           : WideString;
  LastMsgCodeS, LastNewCodeS : WideString;
  MENU_BrowserExec_STRING    : WideString;
  BrowserExecS               : WideString;
  NotAllReceived             : WideString;
  RepeatReceive              : WideString;

  // Error and messages strings
  IconTitle              : WideString;
  IconNotifyFailed       : WideString;
  MenuFailed             : WideString;
  MENU_INTERVAL_STRING   : WideString;
  MENU_CLOSE_STRING      : WideString;
  MENU_UA_STRING         : WideString;
  NATS, RATS             : WideString;
  NewMsg, NewNews, NewNM : WideString;
  SynchroNM              : WideString;
  ErrorCode              : WideString;
  BrowserAndUANecessary  : WideString;
  TrblOFF_MENU           : WideString;
  IsRunString            : WideString;
  MENU_RUN_STRING        : WideString;

  function STC(Tag, Content: WideString): WideString;
  function CarToStrW(Num : cardinal): WideString;
  function CarToStr(Num : cardinal): ANSIString;

  procedure SaveStrings;

implementation

var
  ECode : integer;
  FinalizeString : WideString;
  TagStrings     : array [1 .. 128] of WideString;

function STC(Tag, Content: WideString): WideString;
begin
  result := '<' + Tag + '>' + #13#10 + Content + #13#10 + '</' + Tag + '>' + #13#10 + #13#10;
end;

function CarToStrW(Num : cardinal): WideString;
var
  M : cardinal;
begin
  result := '';
  repeat
    M   := Num mod 10;
    Num := Num div 10;
    M   := M + 48;
    result := WideChar(M) + result; 
  until Num = 0;
end;

function CarToStr(Num : cardinal): ANSIString;
var
  M : cardinal;
begin
  result := '';
  repeat
    M   := Num mod 10;
    Num := Num div 10;
    M   := M + 48;
    result := Char(M) + result; 
  until Num = 0;
end;

procedure SaveStrings;
begin
  RTstring     := CarToStrW(RefreshTime);
  HintTimeS    := CarToStrW(HintTime);
  LastMsgCodeS := CarToStrW(LastMsgCode);
  LastNewCodeS := CarToStrW(LastNewCode);

{  if EnabledUA then EnabledUA_STRING := 'yes'
  else EnabledUA_STRING := 'no';}

  if BrowserExec then BrowserExecS := 'yes'
  else BrowserExecS := 'no';

  if troubleoff then trbleOff:= 'yes'
  else trbleOff := 'no';

  if isRun then
       IsRunString := 'true'
  else IsRunString := 'false';

  FinalizeString := STC(TagStrings[1],  IconTitle)            +
                    STC(TagStrings[2],  IconNotifyFailed)     +
                    STC(TagStrings[3],  MenuFailed)           +
                    STC(TagStrings[4],  MENU_INTERVAL_STRING) +
                    STC(TagStrings[5],  MENU_CLOSE_STRING)    +
                    STC(TagStrings[6],  RTstring)             +
                    STC(TagStrings[7],  trbleOff)             +
                    STC(TagStrings[9],  NATS)                 +
                    STC(TagStrings[10], RATS)                 +
                    STC(TagStrings[11], HintTimeS)            +
                    STC(TagStrings[12], NewMsg)               +
                    STC(TagStrings[13], NewNews)              +
                    STC(TagStrings[14], ErrorCode)            +
                    STC(TagStrings[15], LastMsgCodeS)         +
                    STC(TagStrings[16], LastNewCodeS)         +
                    STC(TagStrings[17], NewNM)                +
                    STC(TagStrings[18], SynchroNM)            +
//                    STC(TagStrings[19], MENU_UA_STRING)       +
//                    STC(TagStrings[20], EnabledUA_STRING)     +
                    STC(TagStrings[21], OurNews)              +
                    STC(TagStrings[22], SiteNews)             +
                    STC(TagStrings[23], BrowserExecS)         +
//                    STC(TagStrings[24], BrowserAndUANecessary)+
                    STC(TagStrings[25], MENU_BrowserExec_STRING) +
                    STC(TagStrings[8],  SiteURL)              +
                    STC(TagStrings[26], FileURL)              +
                    STC(TagStrings[27], NotAllReceived)       +
                    STC(TagStrings[28], RepeatReceive)        +
                    STC(TagStrings[29], TrblOFF_MENU)         +
                    STC(TagStrings[30], IsRunString)          +
                    STC(TagStrings[31], MENU_RUN_STRING);

  if IconTitle <> '' then
    SetFile('strings.ini', FinalizeString)
  else MsgBox(0, 'Error string for write strings.ini', 'Error in FDSC Informer');
end;

const
  STRINGS = 'strings.ini';

procedure _SetCurrentDirectory;
var
  CL  : cardinal;
  pstr: PChar;
  I   : cardinal;
begin
  pstr := GetFileNameA(CL);

  if CL = 0 then exit;
  
  I := CL - 1;
  while pstr[I] <> '\' do dec(I);
  pstr[I] := #0;

  SetCurrentDirectory(pstr);

  LocalFree(cardinal(pstr));
end;

initialization
  TagStrings[1]  := 'IconName';
  TagStrings[2]  := 'IconNotifyFailed';
  TagStrings[3]  := 'MenuFailed';
  TagStrings[4]  := 'MENU_INTERVAL_STRING';
  TagStrings[5]  := 'MENU_CLOSE_STRING';
  TagStrings[6]  := 'RefreshTime';
  TagStrings[7]  := 'trbleOff'; 
  TagStrings[8]  := 'SiteURL';
  TagStrings[9]  := 'NATS';
  TagStrings[10] := 'RATS';
  TagStrings[11] := 'HintTime';
  TagStrings[12] := 'NewMsg';
  TagStrings[13] := 'NewNews';
  TagStrings[14] := 'ConvertError';
  TagStrings[15] := 'LastMsgCode';
  TagStrings[16] := 'LastNewCode';
  TagStrings[17] := 'NewNM';
  TagStrings[18] := 'SynchroNM';
  TagStrings[19] := 'MENU_UA';
  TagStrings[20] := 'EnabledUA';
  TagStrings[21] := 'OurNews';
  TagStrings[22] := 'SiteNews';
  TagStrings[23] := 'BrowserExec';
  TagStrings[24] := 'BrowserAndUANecessary';
  TagStrings[25] := 'BrowserExec_STRING';
  TagStrings[26] := 'FILE_URL';
  TagStrings[27] := 'NotAllReceived';
  TagStrings[28] := 'RepeatReceive';
  TagStrings[29] := 'TrblOFF_MENU';
  TagStrings[30] := 'IsRunFlag';
  TagStrings[31] := 'MENU_RUN_STRING';

  _SetCurrentDirectory;
  IniStr := GetFile(STRINGS, false);

  if IniStr <> '' then
  begin
    IconTitle               := Trim(GetContentOfElement(IniStr, TagStrings[1]));
    IconNotifyFailed        := Trim(GetContentOfElement(IniStr, TagStrings[2]));
    MenuFailed              := Trim(GetContentOfElement(IniStr, TagStrings[3]));
    MENU_INTERVAL_STRING    := Trim(GetContentOfElement(IniStr, TagStrings[4]));
    MENU_CLOSE_STRING       := Trim(GetContentOfElement(IniStr, TagStrings[5]));
    RTstring                := Trim(GetContentOfElement(IniStr, TagStrings[6]));
    trbleOff                := Trim(GetContentOfElement(IniStr, TagStrings[7]));
    SiteURL                 := Trim(GetContentOfElement(IniStr, TagStrings[8]));
    NATS                    := Trim(GetContentOfElement(IniStr, TagStrings[9]));
    RATS                    := Trim(GetContentOfElement(IniStr, TagStrings[10]));
    HintTimeS               := Trim(GetContentOfElement(IniStr, TagStrings[11]));
    NewMsg                  := Trim(GetContentOfElement(IniStr, TagStrings[12]));
    NewNews                 := Trim(GetContentOfElement(IniStr, TagStrings[13]));
    ErrorCode               := Trim(GetContentOfElement(IniStr, TagStrings[14]));
    LastMsgCodeS            := Trim(GetContentOfElement(IniStr, TagStrings[15]));
    LastNewCodeS            := Trim(GetContentOfElement(IniStr, TagStrings[16]));
    NewNM                   := Trim(GetContentOfElement(IniStr, TagStrings[17]));
    SynchroNM               := Trim(GetContentOfElement(IniStr, TagStrings[18]));
//    MENU_UA_STRING          := Trim(GetContentOfElement(IniStr, TagStrings[19]));
//    EnabledUA_STRING        := Trim(GetContentOfElement(IniStr, TagStrings[20]));
    OurNews                 := Trim(GetContentOfElement(IniStr, TagStrings[21]));
    SiteNews                := Trim(GetContentOfElement(IniStr, TagStrings[22]));
    BrowserExecS            := Trim(GetContentOfElement(IniStr, TagStrings[23]));
//    BrowserAndUANecessary   := Trim(GetContentOfElement(IniStr, TagStrings[24]));
    MENU_BrowserExec_STRING := Trim(GetContentOfElement(IniStr, TagStrings[25]));
    FileURL                 := Trim(GetContentOfElement(IniStr, TagStrings[26]));
    NotAllReceived          := Trim(GetContentOfElement(IniStr, TagStrings[27]));
    RepeatReceive           := Trim(GetContentOfElement(IniStr, TagStrings[28]));
    TrblOFF_MENU            := Trim(GetContentOfElement(IniStr, TagStrings[29]));
    IsRunString             := Trim(GetContentOfElement(IniStr, TagStrings[30]));
    MENU_RUN_STRING         := Trim(GetContentOfElement(IniStr, TagStrings[31]));

    if (IconTitle <> '') and (IconNotifyFailed <> '') and (SiteNews <> '') then
    SuccessInternalStringsLoading := true;
  end;

  if SuccessInternalStringsLoading then
  begin

    if IsRunString = 'true' then
      isRun := true;

    Val(RTString,  RefreshTime, ECode);
    Val(HintTimeS, HintTime,    ECode);

    Val(LastMsgCodeS, LastMsgCode, ECode);
    Val(LastNewCodeS, LastNewCode, ECode);

//    EnabledUA   := EnabledUA_STRING = 'yes';
    BrowserExec := BrowserExecS     = 'yes';
    troubleoff  := trbleOff         = 'yes';
  end;

end.

