unit VinUnicode;

// FDSC Informer
//  .. 2006 .

//     /  

interface
                            
uses windows, uConsts;

function  LocalAllocP(Size: cardinal): pointer;

function  GetError(Error: cardinal; MsgBox: boolean = false): PWideChar;
procedure MsgBox(hwnd: cardinal; Str: WideString; caption: PWideChar);
function  StrCopy(Source: WideString; beginI : integer = 1; EndI : integer = -1): WideString;
procedure StrCopyToArray(Source: WideString; WC : PWideChar; beginI : integer = 1; EndI : integer = -1);
function  Trim(const S: WideString): WideString;
function  GetFile(FileName: ANSIString; Msg : boolean = true): WideString;
function  SetFile(FileName: ANSIString; Content: WideString): cardinal;
function  GetFirstString(Str: WideString; SStr: WideString; Pos: integer = 1): cardinal;
function  GetCountString(Str: WideString; SStr: WideString; Pos: integer = 1): integer;
function  GetPosElementByIndex(Str, Element: WideString; Index : cardinal; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'): cardinal;
function  GetContentOfElement(Str: WideString; Element: WideString; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'; OCTag : WideString = '</'): WideString;
function  GetContentOfElementByIndex(Str: WideString; Element: WideString; Index : cardinal; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'; OCTag : WideString = '</'): WideString;

function IsFound(Str: WideString): boolean; //     <generator>korea.sionyx.ru</generator>  false

function ReplaceSmiles(Str: WideString): WideString; //      <img>,     

function SetFileA(FileName: ANSIString; Content: ANSIString): cardinal;

implementation

function LocalAllocP(Size: cardinal): pointer;
begin
  result := pointer(LocalAlloc(LPTR, Size));
end;

function GetError(Error: cardinal; MsgBox: boolean = false): PWideChar;
var
  lpMsgBuf: cardinal;
begin
  result := nil;
  if FormatMessageW(
    FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
    nil,
    Error,
    LANG_NEUTRAL or SUBLANG_DEFAULT shl 10, // Default language
    pointer(@lpMsgBuf),
    0,
    nil
  ) = 0
  then
  begin
    if MsgBox and (FormatMessageA(
      FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
      nil,
      Error,
      LANG_NEUTRAL or SUBLANG_DEFAULT shl 10, // Default language
      pointer(@lpMsgBuf),
      0,
      nil
    ) <> 0)
    then
      begin
        MessageBoxA(0, pointer(lpMsgBuf), 'GetLastError', MB_OK or MB_ICONINFORMATION);
        LocalFree(lpMsgBuf);
        exit;
      end
    else exit;
   end;


  if MsgBox then
  begin
    MessageBoxW(0, pointer(lpMsgBuf), 'GetLastError', MB_OK or MB_ICONINFORMATION);
    LocalFree(lpMsgBuf);
  end
  else result := PWideChar(lpMsgBuf);
end;

procedure MsgBox(hwnd: cardinal; Str: WideString; caption: PWideChar);
begin
  MessageBoxW(hwnd, @Str[1], caption, MB_OK or MB_ICONINFORMATION);
end;

function StrCopy(Source: WideString; beginI, EndI : integer): WideString;
var
  I : integer;
begin
  if BeginI < 1 then BeginI := 1;
  if EndI   = -1 then EndI   := Length(Source);

  SetLength(result, EndI - BeginI + 1);
  for I := 1 to EndI - BeginI + 1 do
  begin
    result[I] := Source[BeginI + I - 1];
  end;
end;

procedure StrCopyToArray(Source: WideString; WC : PWideChar; beginI, EndI : integer);
var
  I : integer;
begin
  if BeginI < 1 then BeginI := 1;
  if   EndI = -1 then   EndI := Length(Source);
  for I := 0 to EndI - beginI do
  begin
    WC[I] := Source[BeginI + I];
  end;
end;

function Trim(const S: WideString): WideString;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then
    Result := ''
  else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := StrCopy(S, I, I + L - I);
  end;
end;

function GetFile(FileName: ANSIString; Msg : boolean = true): WideString;
var
  hFile       : cardinal;
  FileSize    : cardinal;
  ReadedBytes : cardinal;
  p : pointer;
  C : WideChar;
begin
  result := '';

  hFile := CreateFile(PAnsiChar(FileName), GENERIC_READ, FILE_SHARE_READ,
             nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

  if hFile = INVALID_HANDLE_VALUE then
  begin
    if Msg then
      MsgBox(0, 'File "' + FileName + '" may not be open' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    exit;
  end;

  FileSize := SetFilePointer(hFile, 0, nil, FILE_END);
  if FileSize = INVALID_HANDLE_VALUE then
  begin
    if Msg then
      MsgBox(0, 'File "' + FileName +  '" is undefinite size' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    CloseHandle(hFile);
    exit;
  end;

  if FileSize = 0 then
  begin
    if Msg then
      MsgBox(0, 'File "' + FileName +  '" have not size' + #10#13, 'Error in the FDSC Informer');
    CloseHandle(hFile);
    exit;
  end;

  SetFilePointer(hFile, 0, nil, FILE_BEGIN);
  C := #$FEFF;
  ReadFile(hFile, C, 2, ReadedBytes, nil);
  if C <> #$FEFF then
    SetFilePointer(hFile, 0, nil, FILE_BEGIN)
  else Dec(FileSize, 2);

  SetLength(result, FileSize shr 1);

  p := @result[1];
  ReadFile(hFile, p^, FileSize, ReadedBytes, nil);
  if ReadedBytes <> FileSize then
  begin
    result := '';
    if Msg then
      MsgBox(0, 'Read operation with file "' + FileName +  '" is failed' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    CloseHandle(hFile);
    exit;
  end;

  CloseHandle(hFile);
end;

function _CreateFile(FileName: ANSIString; out hFile: cardinal): boolean;
begin
  hFile := CreateFile(PAnsiChar(FileName), GENERIC_WRITE, 0,
             nil, CREATE_ALWAYS, FILE_ATTRIBUTE_TEMPORARY, 0);

  if hFile = INVALID_HANDLE_VALUE then
  begin
    MsgBox(0, 'File "' + FileName + '" may not be created' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    Result := false;
    exit;
  end;
  Result := true;
end;

//    - 1
function SetFileA(FileName: ANSIString; Content: ANSIString): cardinal;
var
  hFile       : cardinal;
  FileSize    : cardinal;
  WritedBytes : cardinal;
  p : pointer;
begin
  result := 1;

  FileSize := length(Content);
  if FileSize = 0 then exit;

  if NOT _CreateFile(FileName, hFile) then exit;

  p := @Content[1];
  WriteFile(hFile, p^, FileSize, WritedBytes, nil);
  if WritedBytes <> FileSize then
  begin
    MsgBox(0, 'Write operation with file "' + FileName +  '" is failed' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    CloseHandle(hFile);
    exit;
  end;

  CloseHandle(hFile);
  result := 0;
end;

function SetFile(FileName: ANSIString; Content: WideString): cardinal;
var
  hFile       : cardinal;
  FileSize    : cardinal;
  WritedBytes : cardinal;
  p : pointer;
  C : WideChar;
begin
  result := 1;

  FileSize := length(Content) * sizeof(WideChar);
  if FileSize = 0 then exit;

  if NOT _CreateFile(FileName, hFile) then exit;

  SetFilePointer(hFile, 0, nil, FILE_BEGIN);
  C := #$FEFF;
  WriteFile(hFile, C, 2, WritedBytes, nil);

  p := @Content[1];
  WriteFile(hFile, p^, FileSize, WritedBytes, nil);
  if WritedBytes <> FileSize then
  begin
    MsgBox(0, 'Write operation with file "' + FileName +  '" is failed' + #10#13 + GetError(GetLastError), 'Error in the FDSC Informer');
    CloseHandle(hFile);
    exit;
  end;

  CloseHandle(hFile);
  result := 0;
end;

//     
// Str  - ,    
// SStr - ,    
// Pos  - ,      ( >0 )
//      SStr   Str
//      -1 ($FFFF FFFF)
function GetFirstString(Str: WideString; SStr: WideString; Pos: integer = 1): cardinal;
var
  I, J, L : integer;
  Flag    : boolean;
begin
  result := $FFFFFFFF;
  if SStr = '' then exit;
  if Pos < 1 then Pos := 1;

  //    Str    Pos
  I := Pos;
  L := length(Str);
  while (I <= L) and (Str[I] <> #0) do
  begin
    //      Str
    Flag := true;
    for J := 1 to length(SStr) do
    begin
      if I + J - 1 > L then exit;
      if SStr[J] <> Str[I + J - 1] then
      begin
        flag := false;
        break;
      end;
    end;

    //         
    if flag then
    begin
      result := cardinal(I);
      break;
    end;
    inc(I);
  end;

end;

//     SStr   Str    1
//     -  0
function GetCountString(Str: WideString; SStr: WideString; Pos: integer = 1): integer;
var
  NP : Cardinal;
begin
  result := -1;
  NP := Pos;
  repeat
    NP := GetFirstString(Str, SStr, NP);
    if NP <> $FFFFFFFF then inc(NP);
    inc(result);
  until NP = $FFFFFFFF;
end;

//    Element    
// OpenTag  CloseTag  ,   Element
//  -1,     Index < 1
function GetPosElementByIndex(Str, Element: WideString; Index : cardinal; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'): cardinal;
var
  Tag : WideString;
  NP  : Cardinal;
begin
  result := 0;

  if (Index < 1) then exit;

  Tag := OpenTag + Element + CloseTag;
  NP := Pos - 1;                    
  repeat
    NP := GetFirstString(Str, Tag, NP + 1);
    inc(result);
  until (NP = $FFFFFFFF) or (result >= Index);
  result := NP;
end;

function GetContentOfElement(Str: WideString; Element: WideString; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'; OCTag : WideString = '</'): WideString;
var
  BeginContent, EndContent : cardinal;
  TagNameSize : cardinal;
  BTag, ETag  : WideString;
begin
  BTag := OpenTag  + Element + CloseTag;
  ETag := OCTag    + Element + CloseTag;
  TagNameSize := length(BTag);

  result := '';

  BeginContent := GetFirstString(Str, BTag, Pos) + TagNameSize;
  if BeginContent < TagNameSize then exit;

  EndContent   := GetFirstString(Str, ETag, BeginContent);
  if EndContent = $FFFFFFFF then exit
  else Dec(EndContent);

  result := StrCopy(Str, BeginContent, EndContent);
end;

function GetContentOfElementByIndex(Str: WideString; Element: WideString; Index : cardinal; Pos: integer = 1; OpenTag: WideString = '<'; CloseTag: WideString = '>'; OCTag : WideString = '</'): WideString;
begin
  result := '';
  Pos    := integer(GetPosElementByIndex(Str, Element, Index, Pos, OpenTag, CloseTag));
  if Pos = -1 then exit;
  result := GetContentOfElement (Str, Element, Pos, OpenTag, CloseTag, OCTag);
end;

function IsFound(Str: WideString): boolean;
begin
  if GetCountString(Str, '<generator>korea.sionyx.ru</generator>') > 0 then
    result := true
  else result := false;
end;

// ---------------------------------------------------------------------------
//      img     

// 
function ReplaceSmiles(Str: WideString): WideString;

var
  DifferenceL: array [1 .. ReplaceStringCount] of integer;

  function GetAddedLength: cardinal;
  var
    I: integer;
    _AddedL     : integer;
  begin
    Result := 0;

    //   -
    for I := 1 to ReplaceStringCount do
    begin
      _AddedL := GetCountString(Str, ReplaceStrings[I]);
      DifferenceL[I] := length(ReplacedStrings[I]) - length(ReplaceStrings[I]);
      inc(Result, _AddedL * DifferenceL[I]);
    end;
  end;

var
  AddedLength : cardinal;
  L, LR       : cardinal;

  procedure SetResultLength;
  begin
    AddedLength := GetAddedLength;

    if AddedLength = 0 then exit;

    L           := length(Str);
    LR          := L + AddedLength;
    SetLength(Result, LR);
  end;

var
  NextReplacePosition : array [1 .. ReplaceStringCount] of cardinal;

  procedure FirstCalcReplacePositions;
  var
    I : integer;
  begin
    for I := 1 to ReplaceStringCount do
      NextReplacePosition[I] := GetFirstString(Str, ReplaceStrings[I]);
  end;

  var
    NearestSmile : cardinal;
    CurrentPos   : cardinal;
    M            : cardinal;  //    

  //    -
  //  false,      img
  function FindNearestSmile: boolean;
  var
    I : integer;

  begin
    NearestSmile := 0;
    M := L;

    //     
    //     ,  NearestSmile    = 0
    for I := 1 to ReplaceStringCount do
      if NextReplacePosition[I] < M then
      begin
        NearestSmile := I;
        M := NextReplacePosition[I];
      end;

    Result := NearestSmile <> 0;
  end;

  procedure DSCopyToResult(var Pos: cardinal; NextPos : cardinal);
  var
    I   : cardinal;
    L   : cardinal;
  begin
    L   := NextPos - Pos;

    if L = 0 then exit;

    for I := Pos to Pos + L - 1 do
      Result[AddedLength + I] := Str[I];

    inc(Pos, L);
  end;

  procedure ReplaceNearestSmile;

    procedure RSCopyToResult(var Pos: cardinal);
    var
      I   : cardinal;
      str : WideString;
      L   : cardinal;
    begin
      str := ReplacedStrings[NearestSmile];
      L   := length(str);
      for I := 1 to L do
        Result[AddedLength + Pos + I - 1] := str[I];

      inc(Pos, length(ReplaceStrings[NearestSmile]));
    end;

  begin
    //   
    //   
    DSCopyToResult(CurrentPos, M);
    RSCopyToResult(CurrentPos);

    inc(AddedLength, DifferenceL[NearestSmile]);

    NextReplacePosition[NearestSmile] := GetFirstString(Str, ReplaceStrings[NearestSmile], CurrentPos);
  end;

begin
  SetResultLength;
  
  if AddedLength = 0 then
  begin
    Result := Str;
    exit;
  end;

  FirstCalcReplacePositions;
  CurrentPos  := 1;
  AddedLength := 0;

  // for I := 1 to LR do Result[I] := #0;

  while FindNearestSmile do ReplaceNearestSmile;
  DSCopyToResult(CurrentPos, M + 1);
end;

end.

