unit uHintIcon;

// FDSC Informer
//  .. 2006 .

//           (balloon hint)

interface

uses ShellApi, uConsts, windows, VinUnicode, InternalStrings;

type
  TTimeoutOrVersion = record
    case Integer of
    0: (uTimeout: cardinal);
    1: (uVersion: cardinal);
  end;

  TNotifyIconDataExW = record
    cbSize: cardinal;
    hWnd: cardinal;
    uID: cardinal;
    uFlags: cardinal;
    uCallbackMessage: cardinal;
    hIcon: cardinal;
    szTip: array[0..127] of WideChar; // Previously 64 chars, now 128

    dwState: cardinal;
    dwStateMask: cardinal;
    szInfo: array[0..255] of WideChar;
    TimeoutOrVersion: TTimeoutOrVersion;
    szInfoTitle: array[0..63] of WideChar;
    dwInfoFlags: cardinal;
 //   guidItem: TGUID;
  end;

  TBalloonHintIcon = (bitNone, bitInfo, bitWarning, bitError);

const
NIIF_NONE = $00000000;
NIIF_INFO = $00000001;
NIIF_WARNING = $00000002;
NIIF_ERROR = $00000003;

NIF_STATE = $00000008;
NIF_INFO = $00000010;
NIF_GUID = $00000020;

  function ShowBalloonHint(Title: WideString; Text: WideString;
      IconType: TBalloonHintIcon): boolean;

  function HideBalloonHint: boolean;

implementation

function HideBalloonHint: boolean;
var NID: TNotifyIconDataExW;
begin
  NID.cbSize := SizeOf(NID);
  NID.hWnd := hdlg;
  NID.uID := 32641;
  NID.uFlags := NIF_INFO;
  NID.szInfo[0] := #0;
  NID.szTip [0] := #0;
  Result:=Shell_NotifyIconW(NIM_MODIFY, @NID);

  IsHint := false; 
end;

function ShowBalloonHint(Title: WideString; Text: WideString;
      IconType: TBalloonHintIcon): boolean;
const
    aBalloonIconTypes: array[TBalloonHintIcon] of Byte =
        (NIIF_NONE, NIIF_INFO, NIIF_WARNING, NIIF_ERROR);
var NID: TNotifyIconDataExW;
  I : integer;
begin
  HideBalloonHint;
  NID.cbSize := SizeOf(NID);
  NID.hWnd   := hDlg;
  NID.uID    := 32641;
  NID.TimeoutOrVersion.uTimeout := 0;
  NID.uFlags := NIF_INFO;

  for I := 0 to length(Text) - 1 do
  begin
    NID.szInfo[I] := Text[I + 1];
  end;
  NID.szInfo[length(Text)] := #0;

  for I := 0 to length(Title) - 1 do
  begin
    NID.szInfoTitle[I] := Title[I + 1];
  end;
  NID.szInfoTitle[length(Title)] := #0;

  NID.dwInfoFlags      := aBalloonIconTypes[IconType];

  Result := Shell_NotifyIconW(NIM_MODIFY, @NID);

  IsHint   := true;
  LastHint := TimerCount;
end;

end.
