unit uInternetAccess;

// FDSC Informer
//  .. 2006 .

//   

interface

uses uConsts, WinInet, windows, VinUnicode;

function  ReadURL(fURL : WideString): WideString;

implementation

uses InternalStrings, uHintIcon;

function OpenInternet(Name: WideString): pointer;
begin
  result := InternetOpenW(@Name[1], INTERNET_OPEN_TYPE_PRECONFIG,
              nil, nil, 0);
end;

procedure CloseURL(hURL : pointer);
begin
  InternetCloseHandle(hURL);
end;

function Connect(hInternet : pointer): pointer;
begin
  result := nil;
  if hInternet = nil  then exit;
  
  result := InternetConnectW(hInternet, @SiteURL[1],
   INTERNET_DEFAULT_HTTP_PORT, 'anonymous', nil, INTERNET_SERVICE_HTTP, 0, 0);
end;

function NewRequest(fURL : WideString; hConnect: pointer): pointer;
begin
  result := nil;
  if hConnect = nil then exit;
  //   nil == 'GET'
  result := HTTPopenRequestW(hConnect, nil, @fURL[1],
                             nil, nil, nil, INTERNET_FLAG_PRAGMA_NOCACHE or INTERNET_FLAG_RELOAD, 0);
end;

function SendRequest(hRequest: pointer): boolean;
begin
  result := false;
  if hRequest = nil then exit;
//  SetLastError(0);
  // 2EE7
  result := HTTPsendRequestW(hRequest, nil, 0, nil, 0);
end;

function HttpQueryInfoW(hRequest: HINTERNET; dwInfoLevel: DWORD;
  lpvBuffer: Pointer; var lpdwBufferLength: DWORD;
  lpdwReserved: pointer): BOOL; stdcall;
            external 'wininet.dll' name 'HttpQueryInfoW';

function SizeQuery(hRequest: pointer; out Size : cardinal): boolean;
var
  RSize  : cardinal;
begin
  RSize  := 4;
  result := HttpQueryInfoW(hRequest, HTTP_QUERY_CONTENT_LENGTH or HTTP_QUERY_FLAG_NUMBER,
                   @Size, RSize, nil);
  if NOT result then Size := 0;
end;

function DataAvailable(hRequest: pointer; out Size : cardinal): boolean;
begin
  result := wininet.InternetQueryDataAvailable(hRequest, Size, 0, 0);
end;

function  ReadURL(fURL : WideString): WideString;
var
  hInternet  : pointer;
  hConnect   : pointer;
  hRequest   : pointer;

  Size       : cardinal;
  B          : boolean;
  Buff       : ANSIString;
  ReadedSize : cardinal;
  I, L       : cardinal;
begin
  result := '';

  hInternet := OpenInternet('FDSC Informer');
  hConnect  := Connect(hInternet);
  hRequest  := NewRequest(fURL, hConnect);
  if (NOT SendRequest(hRequest)) then
  begin
//    ShowBalloonHint('Error in FDSC Informer', 'FDSC Informer can not open Internet access',  bitError);
    // getlastError;
    if hRequest  <> nil then CloseURL(hRequest);
    if hConnect  <> nil then CloseURL(hConnect);
    if hInternet <> nil then CloseURL(hInternet);
    exit;
  end;
  SizeQuery(hRequest, Size);

  inc(Size);
  SetLength(Buff, Size);

  B := false;

  I := 1;
  while true do
  begin
    DataAvailable(hRequest, L);
   	if L = 0 then break;
    if (I + L) > Size then SetLength(Buff, I + L);
    B := InternetReadFile(hRequest, @Buff[I], L, ReadedSize);
    if NOT B then break;
    inc(I, ReadedSize);
  end;

  Buff[I] := #0;

  CloseURL(hRequest);
  CloseURL(hConnect);
  CloseURL(hInternet);
  {$Ifdef FILE_DEBUG_OUTPUT}
  SetFile('tmp.txt', 'error');
  {$ENDIF}
  if B then
  begin
    result := WideString(Buff);
    {$Ifdef FILE_DEBUG_OUTPUT}
    SetFile('tmp.txt', result);
    {$ENDIF}
  end else result := '';
end;

end.
