unit uMenus;

// FDSC Informer
//  .. 2006 .

//     

interface

uses windows, messages, InternalStrings, uConsts;


const
  Nintervals = 7;     //   9, . MENU_INTERVAL  // . initialization

var
  RefreshIntervals : array [1 .. Nintervals] of cardinal;

function  CreateTrayMenu(hwnd : cardinal): cardinal;
function  IntervalSubMenusAllUnCheck(hwnd, hMenu: cardinal): cardinal;
function  IntervalSubMenusCheck(hwnd, hMenu, ID: cardinal): cardinal;
procedure LoadRefreshTimeInMenu(hwnd, hMenu : cardinal);

implementation

function IntervalSubMenusAllUnCheck(hwnd, hMenu: cardinal): cardinal;
var
  I : integer;
begin
  for I := 1 to Nintervals do
  begin
    CheckMenuItem(hMenu, MENU_INTERVAL + I, MF_BYCOMMAND or MF_UNCHECKED);
  end;

  result := 0;
end;

function IntervalSubMenusCheck(hwnd, hMenu, ID: cardinal): cardinal;
begin
  result := CheckMenuItem(hMenu, ID, MF_BYCOMMAND or MF_CHECKED);
end;

procedure LoadRefreshTimeInMenu(hwnd, hMenu : cardinal);
var
  I : cardinal;
begin
  IntervalSubMenusAllUnCheck(hwnd, hMenu);
  for I := 1 to Nintervals do
    if RefreshIntervals[I] = RefreshTime then
    begin
      IntervalSubMenusCheck(hwnd, hMenu, MENU_INTERVAL + I);
      exit;
    end;

  IntervalSubMenusCheck(hwnd, hMenu, MENU_INTERVAL + 1);
  RefreshTime := RefreshIntervals[1];
end;

function CreateIntervalSubMenus(hwnd, hMenu: cardinal): cardinal;
var
  MII : array [1 .. Nintervals] of MenuItemInfoW;
  I   : integer;
  S   : array [1 .. Nintervals] of WideString;
begin
  result := CreateMenu;

  S[1] := '1 min';
  S[2] := '1.5 min';
  S[3] := '2 min';
  S[4] := '3 min';
  S[5] := '4 min';
  S[6] := '5 min';
  S[7] := '10 min';

  for I := Nintervals downto 1 do
  begin
    MII[I].cbSize        := sizeof(MenuItemInfo);
    MII[I].fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
    MII[I].fType         := MFT_STRING;
    MII[I].fState        := MFS_ENABLED;
    MII[I].wID           := MENU_INTERVAL + I;
    MII[I].hSubMenu      := 0;
    MII[I].hbmpChecked   := 0;
    MII[I].hbmpUnchecked := 0;
    MII[I].dwItemData    := 0;
    MII[I].dwTypeData    := @S[I, 1];
    MII[I].cch           := 0;
    MII[I].hbmpItem      := 0;
    InsertMenuItemW(result, 0, true, MII[I]);
  end;
end;

function CreateIntervalMenu(hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_INTERVAL;
  MII.hSubMenu      := CreateIntervalSubMenus(hwnd, hMenu);
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @MENU_INTERVAL_STRING[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;

  result := MII.hSubMenu;

  InsertMenuItemW(hMenu, 0, true, MII);
end;

function CreateCloseMenu(hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_CLOSE;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @MENU_CLOSE_STRING[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;

function CreateBrowserEMenu(hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_BROWSERE;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @MENU_BrowserExec_STRING[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;

{  :   " "
function CreateUAMenu (hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_UA;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @MENU_UA_STRING[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;
}

function CreateRunMenu (hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_RUN;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @MENU_RUN_STRING[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;

function CreateRRMenu(hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_RR;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @RepeatReceive[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;

function CreateTBMenu(hwnd, hMenu: cardinal): cardinal;
var
  MII : MenuItemInfoW;
begin
  MII.cbSize        := sizeof(MenuItemInfo);
  MII.fMask         := MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE;
  MII.fType         := MFT_STRING;
  MII.fState        := MFS_ENABLED;
  MII.wID           := MENU_TBOFF;
  MII.hSubMenu      := 0;
  MII.hbmpChecked   := 0;
  MII.hbmpUnchecked := 0;
  MII.dwItemData    := 0;
  MII.dwTypeData    := @TrblOFF_MENU[1];
  MII.cch           := 0;
  MII.hbmpItem      := 0;
  InsertMenuItemW(hMenu, 0, true, MII);

  result := 0;
end;

function CreateTrayMenu(hwnd : cardinal): cardinal;
begin
  result := CreatePopupMenu;

  CreateCloseMenu(hwnd,    result);
  CreateRRMenu   (hwnd,    result);
  CreateTBMenu   (hwnd,    result);
  CreateBrowserEMenu(hwnd, result);
  CreateRunMenu  (hwnd,    result);
  hSubMenuI := CreateIntervalMenu(hwnd, result);
end;

initialization
  RefreshIntervals[1] := 60;
  RefreshIntervals[2] := 90;
  RefreshIntervals[3] := 120;
  RefreshIntervals[4] := 180;
  RefreshIntervals[5] := 240;
  RefreshIntervals[6] := 300;
  RefreshIntervals[7] := 600;

end.
