unit uRegistry;

// FDSC Informer
//  .. 2006 .

//      (  )

interface

uses windows, VinUnicode, psapi, uConsts;

procedure CheckAutoRun();

function   SetAutoRun(): boolean;
function ResetAutoRun(): boolean;

function GetFileNameW(out CLLength: cardinal): pointer;
function GetFileNameA(out CLLength: cardinal): pointer;

type
  TRegistryOperation  = function (hRegKey: cardinal): boolean;
//  TRegOpenCurrentUser = function (Desired: cardinal; out hRegKey: cardinal): cardinal; stdcall;

implementation

function RegOpenCurrentUser(Desired: cardinal; out hRegKey: cardinal): cardinal; stdcall; external advapi32 name 'RegOpenCurrentUser';

const
  R = STANDARD_RIGHTS_WRITE or KEY_SET_VALUE;

function KeyOperation(Func: TRegistryOperation): boolean;
var
  hRegKey, hRegCUKey: cardinal;
  RE       : cardinal;
//  hLibrary : cardinal;
//  RegOpenCurrentUser: TRegOpenCurrentUser;

begin
  Result := false;
  { //  Windows 98 RegOpenCurrentUser  
  hLibrary := LoadLibrary('advapi32.dll');

  @RegOpenCurrentUser := GetProcAddress(hLibrary, 'RegOpenCurrentUser');

  if @RegOpenCurrentUser <> nil then
    RE := RegOpenCurrentUser(R, hRegCUKey)
  else begin
    RE      := HKEY_CURRENT_USER;
    hRegKey := HKEY_CURRENT_USER;
  end;

  FreeLibrary(hLibrary);  }

  RE := RegOpenCurrentUser(R, hRegCUKey);
  if RE <> ERROR_SUCCESS then exit;

  RE := RegOpenKeyExW(hRegCUKey, 'Software\Microsoft\Windows\CurrentVersion\Run',
                 0, R, HKEY(hRegKey) );

  if RE <> ERROR_SUCCESS then
  begin
    RegCloseKey(hRegCUKey);
    exit;
  end;

  Result := Func(hRegKey);

  RegCloseKey(hRegKey);
  RegCloseKey(hRegCUKey);
end;

function GetFileNameW(out CLLength: cardinal): pointer;
begin
  Result := LocalAllocP(1024 * sizeof(WideChar));

  CLLength := GetModuleFileNameExW(GetCurrentProcess, GetModuleHandle(nil), Result, 1023);
  CLLength := CLLength * sizeof(WideChar);
end;

function GetFileNameA(out CLLength: cardinal): pointer;
begin
  Result := LocalAllocP(1024 * sizeof(Char));
  CLLength := GetModuleFileNameExA(GetCurrentProcess, GetModuleHandleA(nil), Result, 1024);

  { //  Windows 98 GetModuleFileNameExA  
  if CLLength = 0 then
  begin
    CLLength := GetModuleFileNameA(GetModuleHandleA(nil), Result, 1024);
  end; }

  CLLength := CLLength * sizeof(Char);
end;

function   _SetAutoRun(hRegKey: cardinal): boolean;
var
  CLLength : cardinal;
  pstr : pointer;
begin
  Result := false;

  pstr := GetFileNameW(CLLength);

  if CLLength = 0 then
  begin
    LocalFree(cardinal(pstr));
    exit;
  end;

  Result   := RegSetValueExW(hRegKey, 'FDSC informer', 0, REG_SZ, pstr, CLLength + SizeOf(WideChar)) = ERROR_SUCCESS;
  LocalFree(cardinal(pstr));
end;

function   SetAutoRun(): boolean;
begin
  Result := KeyOperation(_SetAutoRun);
end;

function   _ResetAutoRun(hRegKey: cardinal): boolean;
var
  RE: cardinal;
begin
  RE := RegDeleteValueW(hRegKey, 'FDSC informer');
  Result := (RE = ERROR_SUCCESS) or (RE = 2); //    
end;

function ResetAutoRun(): boolean;
begin
  Result := KeyOperation(_ResetAutoRun);
end;

procedure CheckAutoRun();
begin
  if isRun then
  begin
    isRun := SetAutoRun();
  end else
  begin
    ResetAutoRun();
  end;
end;

end.

